Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## javax.portlet
Interface PortletPreferences

All Known Implementing Classes:
  PortletPreferencesImpl

    public interface PortletPreferences

The `PortletPreferences` interface allows the portlet to store configuration data. It is not the purpose of this interface to replace general purpose databases.

There are two different types of preferences:

- modifiable preferences - these preferences can be changed by the portlet in any standard portlet mode (`EDIT, HELP, VIEW`). Per default every preference is modifiable.
- read-only preferences - these preferences cannot be changed by the portlet in any standard portlet mode, but may be changed by administrative modes. Preferences are read-only, if the are defined in the deployment descriptor with `read-only` set to `true`, or if the portlet container restricts write access.

Changes are persisted when the `store` method is called. The `store` method can only be invoked within the scope of a `processAction` call. Changes that are not persisted are discarded when the `processAction` or `render` method ends.

Version:
  $Revision: 5441 $
Author:
  Julien Viet

Method Summary
`java.util.Map` | `getMap()` Returns a `Map` of the preferences.
`java.util.Enumeration` | `getNames()` Returns all of the keys that have an associated value, or an empty `Enumeration` if no keys are available.
`java.lang.String` | `getValue(java.lang.String key, java.lang.String def)` Returns the first String value associated with the specified key of this preference.
`java.lang.String[]` | `getValues(java.lang.String key, java.lang.String[] def)` Returns the String array value associated with the specified key in this preference.
`boolean` | `isReadOnly(java.lang.String key)` Returns true, if the value of this key cannot be modified by the user.
`void` | `reset(java.lang.String key)` Resets or removes the value associated with the specified key.
`void` | `setValue(java.lang.String key, java.lang.String value)` Associates the specified String value with the specified key in this preference.
`void` | `setValues(java.lang.String key, java.lang.String[] values)` Associates the specified String array value with the specified key in this preference.
`void` | `store()` Commits all changes made to the preferences via the `set` methods in the persistent store.

Method Detail

### getMap

    java.util.Map getMap()

  Returns a `Map` of the preferences.

  The values in the returned `Map` are from type String array (`String[]`).

  If no preferences exist this method returns an empty `Map`.

  Returns:
    an immutable `Map` containing preference names as keys and preference values as map values, or an empty `Map` if no preference exist. The keys in the preference map are of type String. The values in the preference map are of type String array (`String[]`).

### getNames

    java.util.Enumeration getNames()

  Returns all of the keys that have an associated value, or an empty `Enumeration` if no keys are available.

  Returns:
    an Enumeration of the keys that have an associated value, or an empty `Enumeration` if no keys are available.

### getValue

    java.lang.String getValue(java.lang.String key,
                              java.lang.String def)
                              throws java.lang.IllegalArgumentException

  Returns the first String value associated with the specified key of this preference. If there is one or more preference values associated with the given key it returns the first associated value. If there are no preference values associated with the given key, or the backing preference database is unavailable, it returns the given default value.

  Parameters:
    `key` - key for which the associated value is to be returned
    `def` - the value to be returned in the event that there is no value available associated with this `key`.
  Returns:
    the value associated with `key`, or `def` if no value is associated with `key`, or the backing store is inaccessible.
  Throws:
    `java.lang.IllegalArgumentException` - if `key` is `null`. (A `null` value for `def` is permitted.)
  See Also:
    `getValues(String,String[])`

### getValues

    java.lang.String[] getValues(java.lang.String key,
                                 java.lang.String[] def)
                                 throws java.lang.IllegalArgumentException

  Returns the String array value associated with the specified key in this preference.

  Returns the specified default if there is no value associated with the key, or if the backing store is inaccessible.

  If the implementation supports stored defaults and such a default exists and is accessible, it is used in favor of the specified default.

  Parameters:
    `key` - key for which associated value is to be returned.
    `def` - the value to be returned in the event that this preference node has no value associated with `key` or the associated value cannot be interpreted as a String array, or the backing store is inaccessible.
  Returns:
    the String array value associated with `key`, or `def` if the associated value does not exist.
  Throws:
    `java.lang.IllegalArgumentException` - if `key` is `null`. (A `null` value for `def` is permitted.)
  See Also:
    `getValue(String,String)`

### isReadOnly

    boolean isReadOnly(java.lang.String key)
                       throws java.lang.IllegalArgumentException

  Returns true, if the value of this key cannot be modified by the user.

  Modifiable preferences can be changed by the portlet in any standard portlet mode (`EDIT, HELP, VIEW`). Per default every preference is modifiable.

  Read-only preferences cannot be changed by the portlet in any standard portlet mode, but inside of custom modes it may be allowed changing them. Preferences are read-only, if they are defined in the deployment descriptor with `read-only` set to `true`, or if the portlet container restricts write access.

  Returns:
    false, if the value of this key can be changed, or if the key is not known
  Throws:
    `java.lang.IllegalArgumentException` - if `key` is `null`.

### reset

    void reset(java.lang.String key)
               throws java.lang.IllegalArgumentException,
                      ReadOnlyException

  Resets or removes the value associated with the specified key.

  If this implementation supports stored defaults, and there is such a default for the specified preference, the given key will be reset to the stored default.

  If there is no default available the key will be removed.

  Parameters:
    `key` - to reset
  Throws:
    `java.lang.IllegalArgumentException` - if key is `null`.
    `ReadOnlyException` - if this preference cannot be modified for this request

### setValue

    void setValue(java.lang.String key,
                  java.lang.String value)
                  throws java.lang.IllegalArgumentException,
                         ReadOnlyException

  Associates the specified String value with the specified key in this preference.

  The key cannot be `null`, but `null` values for the value parameter are allowed.

  Parameters:
    `key` - key with which the specified value is to be associated.
    `value` - value to be associated with the specified key.
  Throws:
    `ReadOnlyException` - if this preference cannot be modified for this request
    `java.lang.IllegalArgumentException` - if key is `null`, or `key.length()` or `value.length` are to long. The maximum length for key and value are implementation specific.
  See Also:
    `setValues(String,String[])`

### setValues

    void setValues(java.lang.String key,
                   java.lang.String[] values)
                   throws java.lang.IllegalArgumentException,
                          ReadOnlyException

  Associates the specified String array value with the specified key in this preference.

  The key cannot be `null`, but `null` values in the values parameter are allowed.

  Parameters:
    `key` - key with which the value is to be associated
    `values` - values to be associated with key
  Throws:
    `java.lang.IllegalArgumentException` - if key is `null`, or `key.length()` is to long or `value.size` is to large. The maximum length for key and maximum size for value are implementation specific.
    `ReadOnlyException` - if this preference cannot be modified for this request
  See Also:
    `setValue(String,String)`

### store

    void store()
               throws java.io.IOException,
                      ValidatorException

  Commits all changes made to the preferences via the `set` methods in the persistent store.

  If this call returns succesfull, all changes are made persistent. If this call fails, no changes are made in the persistent store. This call is an atomic operation regardless of how many preference attributes have been modified.

  All changes made to preferences not followed by a call to the `store` method are discarded when the portlet finishes the `processAction` method.

  If a validator is defined for this preferences in the deployment descriptor, this validator is called before the actual store is performed to check wether the given preferences are vaild. If this check fails a `ValidatorException` is thrown.

  Throws:
    `java.io.IOException` - if changes cannot be written into the backend store
    `ValidatorException` - if the validation performed by the associated validator fails
    `java.lang.IllegalStateException` - if this method is called inside a render call
  See Also:
    `PreferencesValidator`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2008. All Rights Reserved.